#cs(module ssax-tools mzscheme
(require "myenv.ss")
(require "ssax.ss")
;; $Id: ssax-tools.scm,v 1.2 2004/01/31 10:32:33 kl Exp kl $

;=============================================================================
; Convenience functions for simple handling of namespaces 
 
; Reads XML document as SXML tree. NS prefixes declared in XML document
; are used as namespace-id's.
(define (ssax:xml->sxml-autoprefix port)
  (let ((ns-list (ssax:extract-prefix-assigs port)))  
    (file-position port 0)
    (ssax:xml->sxml port ns-list)))

; Reads a root element of XML document and returns a list
; of NS-prefix/URIs declared as a list of pairs.
(define (ssax:extract-prefix-assigs port)
      ;(ssax:skip-pi port)
      (ssax:read-markup-token port)
      (filter-and-map
	(lambda(x)
	  (and (pair? (car x)) (eq? 'xmlns (caar x))))
	(lambda(x)
	  (cons (cdar x) (cdr x)))
	(ssax:read-attributes port '()))
      )

(provide (all-defined)))
